import numpy as np
cimport numpy as np
import cython

@cython.boundscheck(False)
@cython.wraparound(False)
def cycleCython(np.ndarray[np.int_t, ndim=2] A, np.ndarray[np.int_t, ndim=2] vois):
    cdef int nx = A.shape[0], ny = A.shape[1]
    cdef int i, j
    
    for i in xrange(1, nx - 1):
        for j in xrange(1, ny - 1):
            vois[i-1, j-1] = (A[i + 1, j] +
                          A[i + 1, j + 1] +
                          A[i, j + 1] +
                          A[i - 1, j + 1] +
                          A[i - 1, j] +
                          A[i - 1, j - 1] +
                          A[i, j - 1] +
                          A[i + 1, j - 1])
    
    for i in xrange(1, nx - 1):
        for j in xrange(1, ny - 1):
             if vois[i-1, j-1] == 3:
                 A[i, j] = 1 
             elif vois[i-1, j-1] != 2:
                 A[i, j] = 0